#include "WiiBalanceBoardConvert.h"

WiiBalanceBoardConvert::WiiBalanceBoardConvert(void)
{
}

WiiBalanceBoardConvert::~WiiBalanceBoardConvert(void)
{
}


void WiiBalanceBoardConvert::SetWiiExtensionCalibration(BYTE *buff)
{
	BalanceBoardState.CalibrationInfo.Kg0.TopRight =	(buff[10] << 8) | buff[11];
	BalanceBoardState.CalibrationInfo.Kg0.BottomRight =	(buff[12] << 8) | buff[13];
	BalanceBoardState.CalibrationInfo.Kg0.TopLeft =		(buff[14] << 8) | buff[15];
	BalanceBoardState.CalibrationInfo.Kg0.BottomLeft =	(buff[16] << 8) | buff[17];
	BalanceBoardState.CalibrationInfo.Kg17.TopRight =	(buff[18] << 8) | buff[19];
	BalanceBoardState.CalibrationInfo.Kg17.BottomRight =(buff[20] << 8) | buff[21];
	BalanceBoardState.CalibrationInfo.Kg17.TopLeft =	(buff[28] << 8) | buff[29];
	BalanceBoardState.CalibrationInfo.Kg17.BottomLeft =	(buff[30] << 8) | buff[31];
	BalanceBoardState.CalibrationInfo.Kg34.TopRight =	(buff[32] << 8) | buff[33];
	BalanceBoardState.CalibrationInfo.Kg34.BottomRight =(buff[34] << 8) | buff[35];
	BalanceBoardState.CalibrationInfo.Kg34.TopLeft =	(buff[36] << 8) | buff[37];
	BalanceBoardState.CalibrationInfo.Kg34.BottomLeft =	(buff[38] << 8) | buff[39];
}

void WiiBalanceBoardConvert::ParseExtension(BYTE *buff)
{
	// ̓ZT̐f[^
	BalanceBoardState.SensorValuesRaw.TopRight = (int)((buff[3] << 8) | buff[4]);
	BalanceBoardState.SensorValuesRaw.BottomRight = (int)((buff[5] << 8) | buff[6]);
	BalanceBoardState.SensorValuesRaw.TopLeft = (int)((buff[7] << 8) | buff[8]);
	BalanceBoardState.SensorValuesRaw.BottomLeft = (int)((buff[9] << 8) | buff[10]);

	// Kgϊ
	BalanceBoardState.SensorValuesKg.TopLeft     = GetBalanceBoardSensorValue(BalanceBoardState.SensorValuesRaw.TopLeft, BalanceBoardState.CalibrationInfo.Kg0.TopLeft, BalanceBoardState.CalibrationInfo.Kg17.TopLeft, BalanceBoardState.CalibrationInfo.Kg34.TopLeft);
	BalanceBoardState.SensorValuesKg.TopRight    = GetBalanceBoardSensorValue(BalanceBoardState.SensorValuesRaw.TopRight, BalanceBoardState.CalibrationInfo.Kg0.TopRight, BalanceBoardState.CalibrationInfo.Kg17.TopRight, BalanceBoardState.CalibrationInfo.Kg34.TopRight);
	BalanceBoardState.SensorValuesKg.BottomLeft  = GetBalanceBoardSensorValue(BalanceBoardState.SensorValuesRaw.BottomLeft, BalanceBoardState.CalibrationInfo.Kg0.BottomLeft, BalanceBoardState.CalibrationInfo.Kg17.BottomLeft, BalanceBoardState.CalibrationInfo.Kg34.BottomLeft);
	BalanceBoardState.SensorValuesKg.BottomRight = GetBalanceBoardSensorValue(BalanceBoardState.SensorValuesRaw.BottomRight, BalanceBoardState.CalibrationInfo.Kg0.BottomRight, BalanceBoardState.CalibrationInfo.Kg17.BottomRight, BalanceBoardState.CalibrationInfo.Kg34.BottomRight);

	double Kx = (BalanceBoardState.SensorValuesKg.TopLeft + BalanceBoardState.SensorValuesKg.BottomLeft) / (BalanceBoardState.SensorValuesKg.TopRight + BalanceBoardState.SensorValuesKg.BottomRight);
	double Ky = (BalanceBoardState.SensorValuesKg.TopLeft + BalanceBoardState.SensorValuesKg.TopRight) / (BalanceBoardState.SensorValuesKg.BottomLeft + BalanceBoardState.SensorValuesKg.BottomRight);

	BalanceBoardState.WeightKg = (BalanceBoardState.SensorValuesKg.TopLeft + BalanceBoardState.SensorValuesKg.TopRight + BalanceBoardState.SensorValuesKg.BottomLeft + BalanceBoardState.SensorValuesKg.BottomRight) / 4.0f;

	// dS̎Zo
	BalanceBoardState.CenterOfGravity.X = (int)(((double)(Kx - 1) / (double)(Kx + 1)) * (double)(-43 / 2));
	BalanceBoardState.CenterOfGravity.Y = -(int)(((double)(Ky - 1) / (double)(Ky + 1)) * (double)(-24 / 2));

	if(BalanceBoardState.WeightKg < 3)
	{
		BalanceBoardState.CenterOfGravity.X = 0;
		BalanceBoardState.CenterOfGravity.Y = 0;
	}
}

double WiiBalanceBoardConvert::GetBalanceBoardSensorValue(int sensor, int min, int mid, int max)
{
	if(max == mid || mid == min)
	{
		return 0;
	}

	if(sensor < mid)
	{
		return 68.0f * ((double)(sensor - min) / (mid - min));
	}
	else
	{
		return 68.0f * ((double)(sensor - mid) / (max - mid)) + 68.0f;
	}	
}