#pragma once
#include <windows.h>

class WiiClassicControllerConvert
{
public:
	WiiClassicControllerConvert(void);
	~WiiClassicControllerConvert(void);

	struct Point3
	{
		int X;
		int Y;
		int Z;
	};

	struct Point3F
	{
		double X;
		double Y;
		double Z;
	};

	//--WiiRemote-------
	struct WiiButtonState
	{
		bool A;
		bool B;
		bool Minus;
		bool Home;
		bool Plus;
		bool One;
		bool Two;
		bool Up;
		bool Down;
		bool Left;
		bool Right;
	};

	struct WiiRemoteAccelState
	{
		Point3 RawValues;
		Point3F Values;
	};	

	struct WiiRemoteAccelCalibration
	{
		int X0;
		int Y0;
		int Z0;
		int XG;
		int YG;
		int ZG;
	};

	struct WiiRemoteState
	{
		WiiButtonState ButtonState;
		WiiRemoteAccelState AccelState;
		WiiRemoteAccelCalibration AccelCalibrationInfo;
	};

	WiiRemoteState mWiiRemoteState;
	//--WiiRemote񂱂܂-------

	//--ClassicController-------
	struct WiiClassicControllerButtonState
	{
		bool A;
		bool B;
		bool X;
		bool Y;
		bool Minus;
		bool Home;
		bool Plus;
		bool Up;
		bool Down;
		bool Left;
		bool Right;
		bool L;
		bool R;
		bool ZL;
		bool ZR;
	};
	
	struct WiiClassicControllerAnalog
	{
		int Trigger;
		int StickX;
		int StickY;
	};

	struct WiiClassicControllerAnalogState
	{
		WiiClassicControllerAnalog Left;
		WiiClassicControllerAnalog Right;
	};

	struct WiiClassicControllerTriggerCalibration
	{
		int Max;
		int Min;
	};

	struct WiiClassicControllerStickCalibration
	{
		int X0;
		int XMax;
		int XMin;
		int Y0;
		int YMax;
		int YMin;
	};

	struct WiiClassicControllerCalibration
	{
		WiiClassicControllerTriggerCalibration LeftTrigger;
		WiiClassicControllerTriggerCalibration RightTrigger;
		WiiClassicControllerStickCalibration LeftStick;
		WiiClassicControllerStickCalibration RightStick;
	};

	struct WiiClasicControllerState
	{
		WiiClassicControllerButtonState ButtonState;
		WiiClassicControllerAnalogState AnalogState;
		WiiClassicControllerCalibration CalibrationInfo;
	};

	WiiClasicControllerState mWiiClasicControllerState;
	//--ClassicController񂱂܂-------

	void SetWiiRemoteCalibration(BYTE *buff);
	void SetWiiClassicControllerCalibration(BYTE *buff);
	void ParseButtons(BYTE *buff);
	void ParseAccel(BYTE *buff);
	void ParseAnalog(BYTE *buff);
};
