#include "WiiMotionPlusConvert.h"

WiiMotionPlusConvert::WiiMotionPlusConvert(void)
{
	//
	mMotionPlusState.gyro.yaw = 0;
	mMotionPlusState.gyro.pitch = 0;
	mMotionPlusState.gyro.roll = 0;
	mMotionPlusState.gyro_speed.yaw_Speed = 0;
	mMotionPlusState.gyro_speed.pitch_Speed = 0;
	mMotionPlusState.gyro_speed.roll_Speed = 0;
	mMotionPlusState.AveCalib.yaw0 = 0;
	mMotionPlusState.AveCalib.pitch0 = 0;
	mMotionPlusState.AveCalib.roll0 = 0;

	yaw_old = 0;
	pitch_old = 0;
	roll_old = 0;

}

WiiMotionPlusConvert::~WiiMotionPlusConvert(void)
{
}

void WiiMotionPlusConvert::ParseExtension(BYTE *buff){

	//f[^̌vZ
	short yaw = ((unsigned short)buff[9] >> 2) << 8 | (unsigned short) buff[6];
	short pitch = ((unsigned short)buff[11] >> 2) << 8 | (unsigned short) buff[8];
	short roll = ((unsigned short) buff[10] >> 2) << 8 | (unsigned short) buff[7];

	if( ( yaw != mMotionPlusState.gyro.yaw) | (pitch != mMotionPlusState.gyro.pitch) | ( roll != mMotionPlusState.gyro_speed.roll_Speed)){
		mMotionPlusState.gyro.yaw =yaw;
		mMotionPlusState.gyro.pitch = pitch;
		mMotionPlusState.gyro.roll = roll;

		//XP[fbit
		bool yaw_slow = buff[9] & 0x02;
		bool pitch_slow = buff[9] & 0x01;
		bool roll_slow = buff[10] & 0x02;

		//XP[̌
		float yaw_scale = yaw_slow? 0.05f: 0.25f;
		float pitch_scale = pitch_slow? 0.05f: 0.25f;
		float roll_scale = roll_slow? 0.05f: 0.25f;

		//eXs[ȟvZ
		mMotionPlusState.gyro_speed.yaw_Speed = -( mMotionPlusState.gyro.yaw - 0x1f7f - mMotionPlusState.AveCalib.yaw0) * yaw_scale;
		mMotionPlusState.gyro_speed.pitch_Speed = -(mMotionPlusState.gyro.pitch - 0x1f7f - mMotionPlusState.AveCalib.pitch0) * pitch_scale;
		mMotionPlusState.gyro_speed.roll_Speed = -(mMotionPlusState.gyro.roll - 0x1f7f - mMotionPlusState.AveCalib.roll0) * roll_scale;
	}

}

void WiiMotionPlusConvert::ParseMotionPlusCalib(BYTE* buff,int loop){

	short yaw = ((unsigned short)buff[9] >> 2) << 8 | (unsigned short) buff[6];
	short pitch = ((unsigned short)buff[11] >> 2) << 8 | (unsigned short) buff[8];
	short roll = ((unsigned short) buff[10] >> 2) << 8 | (unsigned short) buff[7];

	if((yaw_old!=0)|(pitch_old!=0)|(roll_old!=0)){
		mMotionPlusState.AveCalib.yaw0 = mMotionPlusState.AveCalib.yaw0 + (yaw-yaw_old) / loop;
		mMotionPlusState.AveCalib.pitch0 = mMotionPlusState.AveCalib.pitch0 + (pitch-pitch_old) / loop;
		mMotionPlusState.AveCalib.roll0 = mMotionPlusState.AveCalib.roll0 + (roll-roll_old) / loop;
	}

	yaw_old = yaw;
	pitch_old = pitch;
	roll_old = roll;
}