#pragma once
#include <windows.h>
#include "WiiRemoteConvert.h"
#include <iostream>

class WiiNunchakuConvert : public WiiRemoteConvert
{
private:

public:
	WiiNunchakuConvert(void);
	~WiiNunchakuConvert(void);

	//--k`N--------
	struct Point2
	{
		int X;
		int Y;
	};

	struct NunchukAccelCalibrationInfo
	{
		int X0;
		int Y0;
		int Z0;
		int XG;
		int YG;
		int ZG;
	};

	struct NunchukCalibrationInfo
	{
		NunchukAccelCalibrationInfo AccelCalibration;
		int MaxX;
		int MinX;
		int MidX;
		int MaxY;
		int MinY;
		int MidY;
	};
	
	struct NunchukAccelState
	{
		Point3 RawValues;
		Point3 Values;
	};

	struct NunchukParameter
	{
		Point2 Joystick;
		Point2 RawJoystick;
		NunchukAccelState AccelState;
		bool C;
		bool Z;
		NunchukCalibrationInfo CalibrationInfo;
	};

	NunchukParameter NunchukState;
	//--k`N--------

	void SetWiiExtensionCalibration(BYTE* buff);
	void ParseExtension(BYTE* buff);
};
